# This code is provided under a CC-BY-4.0 License
# Published in: Eric D. Taillard
# Design of Heuristic Algorithms for Hard Optimization, Springer Nature, 2023
# https://link.springer.com/book/10.1007/978-3-031-13714-3

from random_generators import unif 

######### Random mutation of a permutation
def mutate(mutation_rate,
           p):                                          # Permutation to mutate

    n = len(p)
    mutations = int(mutation_rate * n / 2.0)
    for _ in range(mutations):
        i = unif(0, n - 1)
        j = unif(0, n - 1)
        p[i], p[j] = p[j], p[i]
    return p
