# This code is provided under a CC-BY-4.0 License
# Published in: Eric D. Taillard
# Design of Heuristic Algorithms for Hard Optimization, Springer Nature, 2023
# https://link.springer.com/book/10.1007/978-3-031-13714-3

import math
from random_generators import unif 

######### Selection operator for reproduction based on the rank
def rank_based_selection(size):
    return int(size \
               - math.ceil(math.sqrt(.25 + 2*unif(1, size*(size + 1)/2)) - .5))
